
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Forum_postsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const forum_posts = await db.forum_posts.create(
            {
                id: data.id || undefined,
        
        body_text: data.body_text
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        posted_at: data.posted_at
        ||
        null
            ,
            
        upvotes_count: data.upvotes_count
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await forum_posts.setThread( data.thread || null, {
            transaction,
        });
        
        await forum_posts.setAuthor( data.author || null, {
            transaction,
        });
        
        await forum_posts.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return forum_posts;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const forum_postsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                body_text: item.body_text
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                posted_at: item.posted_at
            ||
            null
            ,
            
                upvotes_count: item.upvotes_count
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const forum_posts = await db.forum_posts.bulkCreate(forum_postsData, { transaction });

        // For each item created, replace relation files
        

        return forum_posts;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const forum_posts = await db.forum_posts.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.body_text !== undefined) updatePayload.body_text = data.body_text;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.posted_at !== undefined) updatePayload.posted_at = data.posted_at;
        
        
        if (data.upvotes_count !== undefined) updatePayload.upvotes_count = data.upvotes_count;
        
        
        updatePayload.updatedById = currentUser.id;

        await forum_posts.update(updatePayload, {transaction});

        
        
        if (data.thread !== undefined) {
            await forum_posts.setThread(
              
              data.thread,
              
              { transaction }
            );
        }
        
        if (data.author !== undefined) {
            await forum_posts.setAuthor(
              
              data.author,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await forum_posts.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return forum_posts;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const forum_posts = await db.forum_posts.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of forum_posts) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of forum_posts) {
                await record.destroy({transaction});
            }
        });


        return forum_posts;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const forum_posts = await db.forum_posts.findByPk(id, options);

        await forum_posts.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await forum_posts.destroy({
            transaction
        });

        return forum_posts;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const forum_posts = await db.forum_posts.findOne(
            { where },
            { transaction },
        );

        if (!forum_posts) {
            return forum_posts;
        }

        const output = forum_posts.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.thread = await forum_posts.getThread({
            transaction
        });
        
        
        output.author = await forum_posts.getAuthor({
            transaction
        });
        
        
        output.organizations = await forum_posts.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.forum_threads,
        as: 'thread',
        
        where: filter.thread ? {
          [Op.or]: [
            { id: { [Op.in]: filter.thread.split('|').map(term => Utils.uuid(term)) } },
            {
              thread_title: {
                [Op.or]: filter.thread.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'author',
        
        where: filter.author ? {
          [Op.or]: [
            { id: { [Op.in]: filter.author.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.author.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.body_text) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'forum_posts',
                        'body_text',
                        filter.body_text,
                    ),
                };
            }
            

            
            

            
            if (filter.posted_atRange) {
                const [start, end] = filter.posted_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    posted_at: {
                    ...where.posted_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    posted_at: {
                    ...where.posted_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.upvotes_countRange) {
                const [start, end] = filter.upvotes_countRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    upvotes_count: {
                    ...where.upvotes_count,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    upvotes_count: {
                    ...where.upvotes_count,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.forum_posts.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'forum_posts',
                        'body_text',
                        query,
                    ),
                ],
            };
        }

        const records = await db.forum_posts.findAll({
            attributes: [ 'id', 'body_text' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['body_text', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.body_text,
        }));
    }

    
};

